Subject: Re: [RFC PATCH 4/6] leds: trigger: add offload-phy-activity trigger

From: Marek Behún <[email-masked]>
Date: Mon, 8 Nov 2021 11:00:58 +0100

On Sun, 7 Nov 2021 23:43:37 +0100
Ansuel Smith <[email-masked]> wrote:

> On Sun, Nov 07, 2021 at 11:10:09PM +0100, Marek Behún wrote:
> > On Sun,  7 Nov 2021 18:57:16 +0100
> > Ansuel Smith <[email-masked]> wrote:
> >   
> > > Add Offload Trigger for PHY Activity. This special trigger is used to
> > > configure and expose the different HW trigger that are provided by the
> > > PHY. Each offload trigger can be configured by sysfs and on trigger
> > > activation the offload mode is enabled.
> > > 
> > > This currently implement these hw triggers:
> > >   - blink_tx: Blink LED on tx packet receive
> > >   - blink_rx: Blink LED on rx packet receive
> > >   - blink_collision: Blink LED on collision detection
> > >   - link_10m: Keep LED on with 10m link speed
> > >   - link_100m: Keep LED on with 100m link speed
> > >   - link_1000m: Keep LED on with 1000m link speed
> > >   - half_duplex: Keep LED on with half duplex link
> > >   - full_duplex: Keep LED on with full duplex link
> > >   - linkup_over: Keep LED on with link speed and blink on rx/tx traffic
> > >   - power_on_reset: Keep LED on with switch reset
> > >   - blink_2hz: Set blink speed at 2hz for every blink event
> > >   - blink_4hz: Set blink speed at 4hz for every blink event
> > >   - blink_8hz: Set blink speed at 8hz for every blink event
> > >   - blink_auto: Set blink speed at 2hz for 10m link speed,
> > >       4hz for 100m and 8hz for 1000m
> > > 
> > > The trigger will read the supported offload trigger in the led cdev and
> > > will expose the offload triggers in sysfs and then activate the offload
> > > mode for the led in offload mode has it configured by default. A flag is
> > > passed to configure_offload with the related rule from this trigger to
> > > active or disable.
> > > It's in the led driver interest the detection and knowing how to
> > > elaborate the passed flags.
> > > 
> > > The different hw triggers are exposed in the led sysfs dir under the
> > > offload-phy-activity subdir.  
> > 
> > NAK. The current plan is to use netdev trigger, and if it can
> > transparently offload the settings to HW, it will.
> > 
> > Yes, netdev trigger currently does not support all these settings.
> > But it supports indicating link and blinking on activity.
> > 
> > So the plan is to start with offloading the blinking on activity, i.e.
> > I the user does
> >   $ cd /sys/class/leds/<LED>
> >   $ echo netdev >trigger
> >   $ echo 1 >rx
> >   $ echo eth0 >device_name
> > 
> > this would, instead of doing blinking in software, do it in HW instead.
> > 
> > After this is implemented, we can start working on extending netdev
> > trigger to support more complicated features.
> > 
> > Marek  
> 
> Using the netdev trigger would cause some problem. Most of the switch
> can run in SW mode (with blink controlled by software of always on) or
> be put in HW mode and they will autonomously control blinking and how
> the LED will operate. So we just need to provide a way to trigger this
> mode and configure it. Why having something that gets triggered and then
> does nothing as it's offloaded?

Nothing gets triggered. In my last proposal, when the netdev trigger
gets activated, it will first try to offload() itself to the LED
controller. If the controller supports offloading, then netdev trigger
won't be blinking the LEDs.

See my last proposal at
https://lore.kernel.org/linux-leds/[email-masked]/

> The current way to configure this is very similar... Set the offload
> trigger and use the deidcated subdir to set how the led will
> blink/behave based on the supported trigger reported by the driver.
> 
> There is no reason to set a device_name as that would be hardcoded to
> the phy (and it should not change... again in HW we can't control that
> part, we can just tell the switch to blink on packet tx on that port)
> 
> So really the command is:
>   $ cd /sys/class/leds/<LED>
>   $ echo netdev > offload-phy-activity
>   $ cd offload-phy-activity
>   $ echo 1 > tx-blink
> 
> And the PHY will blink on tx packet.

So there are now 2 different ways to set a LED to blink on tx activity:
the first one is via standard netdev trigger, the second one is this.
That is wrong.

> I understand this should be an extension of netdev as they would do
> similar task but honestly polluting the netdev trigger of if and else to
> disable part of it if an offload mode can be supported seems bad and
> confusionary. At this point introduce a dedicated trigger so an user can
> switch between them. That way we can keep the flexibility of netdev
> trigger that will always work but also permit to support the HW mode
> with no load on the system.

The rationale behind offloading netdev trigger is that it can use
standard, existing sysfs ABI. If the driver finds out that it can
offload the blinking to HW, it will.

This is similar to how other kernel APIs do this.

For example for an ethernet switch, we have DSA. So that we don't need
a specific way to say to the switch which ports it should bridge. All
ports are exported by the switch driver as standard network devices,
and if we bridge them via standard API, the kernel, upon finding out
that the bridging can be offloading to the switch chip, does that.

Marek